      subroutine exch_3d_1(F_TMP, hkl_min, hkl_max, FFT_3D, npix_row)
C
      implicit none

      include 'mpif.h'
      include '../include/allprogs.inc'
 
C Arguments
C
      integer hkl_min, hkl_max, npix_row
C 
      complex F_TMP(1) 
C which are slabs of (0:hkl_max, hkl_min:hkl_max,
C                   frst_lst_y(1,iam):frst_lst_y(2,iam)
C    
      complex FFT_3D( frst_lst_iq(1,iam):frst_lst_iq(2,iam), 
     +                hkl_min:hkl_max, npix_row)
C =====================================================================
C                                 p0      p1
Cji we exchange data ----    to  ----    -----
Cji                  |a1|        |a1|    | b1|
Cji                  |  |        |  |    |   |  
Cji                  ----        ----    -----
Cji                  | b1|       |a2|    | b2|
Cji                  |   |       |  |    |   |
Cji                  -----       |  |    |   |
Cji                  |c1|        ----    -----
Cji                  |  |        |a3|    | b3|
Cji                  ----        |  |    |   | 
Cji                              ----    -----
C  Local                          
C
      integer node, send_offset, recv_offset,
     +        send_factor, recv_factor
      character(len=10) :: subname = 'EXCH_3D_1'
C
      if( num_nodes .gt. 1 ) then
 
        send_offset = 0
        recv_offset = 0

        send_factor = ( hkl_max - hkl_min + 1)
     +           * ( frst_lst_y(2,iam) - frst_lst_y(1,iam) + 1)
        recv_factor = ( hkl_max - hkl_min + 1)
     +           * ( frst_lst_iq(2,iam) - frst_lst_iq(1,iam) + 1)

        do node = 0, num_nodes-1
          scounts(node) = send_factor
     +           * (frst_lst_iq(2,node)- frst_lst_iq(1,node) + 1)
          sdispls(node) = send_offset
          send_offset   = send_offset + scounts(node)

          rcounts(node) = recv_factor
     +           * (frst_lst_y(2,node) - frst_lst_y(1,node) + 1)
          rdispls(node) = recv_offset
          recv_offset   = recv_offset + rcounts(node)
       enddo

C       Send data from F_VRU; receive data in F_VRU_TMP
        call mpi_alltoallv (F_TMP, scounts, sdispls,
     +    mpi_complex, FFT_3D, rcounts, rdispls, mpi_complex,
     +    mpi_comm_world, mpi_err)
C 
        if( mpi_err .ne. 0 ) then
          call error_stop(progname,subname,
     +             ' Error in alltoall communication !')
        endif
      endif
C
      return
      end subroutine exch_3d_1
