      subroutine realtocomplx(hkl_min, hkl_max, 
     +     first_iq, last_iq, interpolants, f_hkl, 
     +     algorithm)
C                                                   SOLVE_BY_INTERP_SLAB
C
C **********************************************************************
C *                                                                    *
C * Subroutine: realtocomplex                                          *
C * Author: Yongchang Ji (yji@cs.ucf.edu)                              *
C * Modification history:                                              *
C *   - RSS, Added algorithm argument. Allows us to merge the          *
C *          versions from algorithms 1 and 3                          *
C *   - Yongchang Ji, Final Version, Aug.2000 -- Jan. 2002             *
C *                                                                    *
C **********************************************************************
      implicit none

C     Subroutine arguments
      integer  hkl_min, hkl_max, first_iq, last_iq
      integer algorithm

#ifdef SPREC
      real  interpolants(3, 
     +             hkl_min:hkl_max, hkl_min:hkl_max,first_iq:last_iq)
#else
      double precision  interpolants(3, 
     +             hkl_min:hkl_max, hkl_min:hkl_max,first_iq:last_iq)
#endif

      complex  f_hkl(hkl_min:hkl_max, hkl_min:hkl_max, 
     +               first_iq:last_iq)

C     Local variables
      integer  il, ik, ih
      
      if(algorithm .eq. 1) then
         do il = first_iq, last_iq
            do ik = hkl_min, hkl_max
               do ih = hkl_min, hkl_max
                  if (interpolants(1,ih,ik,il).GT.0.0) then
                     f_hkl(ih,ik,il) =
     +                    cmplx(interpolants(2,ih,ik,il)/
     +                    interpolants(1,ih,ik,il),
     +                    interpolants(3,ih,ik,il)/
     +                    interpolants(1,ih,ik,il))
                  else 
                     f_hkl(ih,ik,il) = (0.0, 0.0)
                  endif
               enddo
            enddo
         enddo
      endif
      
      if(algorithm .eq. 3) then
         do il = first_iq, last_iq
            do ik = hkl_min, hkl_max
               do ih = hkl_min, hkl_max
                  f_hkl(ih,ik,il) =
     +                 cmplx(interpolants(2,ih,ik,il),
     +                 interpolants(3,ih,ik,il))
               enddo
            enddo
         enddo
      endif
      
      return
      end subroutine realtocomplx
