      SUBROUTINE imgcompcet(fft2, hkl_min, hkl_max, fft1,
     +     disef, abs_ctf2, rmin, rmax, retvalue)
      
Cji  compare the two complex image with radius from rmin to 
Cji  rmax for center correction
Cji  disef is the weight which apply to the distance, according to 
cji  the radius and funcweight
Cji  but for center correction, we donot want to use this disef weight.
Cji  SO the center correction will be more better with distance method.

      IMPLICIT NONE
      include  '../include/allprogs.inc'
      
C     Subroutine arguments
      INTEGER  hkl_min, hkl_max
      COMPLEX  FFT1(0:hkl_max,hkl_min:hkl_max)
      COMPLEX  FFT2(0:hkl_max,hkl_min:hkl_max)
      real     disef(0:hkl_max,hkl_min:hkl_max)
      real     abs_ctf2(0:hkl_max,hkl_min:hkl_max)
      REAL     retvalue, rmin, rmax
      
C     Local variables
      double precision dvalue
      REAL*4  tmp
      integer  rmaxi ,I,J, count
      Complex  tt
      real     dis

C     use distance: sqrt((A1-A2)**2 + (b1-b2)**2)
C              dvalue = dvalue + dis * disef(i,j) * (abs_ctf2(i,j)+0.01)
      
      retvalue = 1.0E+37
      dvalue = 0.0
      count = 0
      rmaxi = min(hkl_max,int(rmax)+1)
      Do j = -rmaxi, rmaxi
         tmp = j*j
         if ((tmp.le.rmax**2) .and. (tmp.ge.rmin**2)) then
            count = count + 1
            tt = FFT1(0,j) - FFT2(0,j)
            dis = sqrt(real(tt)**2 + aimag(tt)**2)
            dvalue = dvalue + dis * (abs_ctf2(0,j)+0.01)
         endif
         Do i = 1, rmaxi
            tmp = i*i+j*j
            if ((tmp.le.rmax**2) .and. (tmp.ge.rmin**2)) then
               count = count + 2
               tt = FFT1(i,j) - FFT2(i,j)
               dis = sqrt(real(tt)**2 + aimag(tt)**2)
               dvalue = dvalue + 2 * dis * (abs_ctf2(i,j)+0.01)
            endif
         enddo
      enddo
      
      if (count .ge. 1) retvalue = dvalue / count
      
      RETURN
      END SUBROUTINE imgcompcet
