      subroutine map_fft_fill (map, ncol, nrow, fft, idim1, idim2, bkg)

C     Load ncol x nrow "map" section into "fft" array to compute fft
C      
C     Beware: it is ***important*** that the data be properly floated
C     before the data are fourier transformed.
C      
C     May 1989  purdue university vax 8550, t. baker
C     Modified 17-dec-1997 by t. baker (get rid of em.cmm)
C     Modified 30-nov-1999 by tsb (get rid of fft_iend)
C     Geneal cleanup, 21-Jul-2006, R. Sinkovits
      
      implicit none

      integer*4, intent(in) :: ncol, nrow
      integer*4, intent(in) :: idim1, idim2
      real*4, intent(in)    :: map(ncol,nrow), bkg

      real*4, intent(out)   :: fft(2*idim1,idim2)
      
      integer*4 i, j
      real*4 tmp

      fft = 0.0 !Fortran 90 array syntax
      
      if(bkg == 0.0) then
         do j = 1,nrow
            do i = 1,ncol
               tmp            = map(i,j)
               fft((2*i)-1,j) = tmp
            enddo
         enddo
      else
         do j = 1,nrow
            do i = 1,ncol
               tmp            = map(i,j) - bkg
               fft((2*i)-1,j) = tmp
            enddo
         enddo
      endif
      
      return
      end subroutine map_fft_fill
