      SUBROUTINE PMAP_FFT (PMAP, PFFT, NROT, NANNULI)

C     ROUTINE TO COMPUTE FFT OF POLAR MAP
C     
C     COLUMNS OF THE POLAR MAP ARE FOURIER TRANSFORMED
C     
C     AUGUST 1992  PURDUE UNIVERSITY VAX 8550, T. BAKER
C     MODIFIED 15-DEC-1997 BY T. BAKER (RID OF EM.CMM)
C     Modified 18-aug-2006, R Sinkovits - use automatic array A

      IMPLICIT NONE

      INTEGER*4, INTENT(IN) :: NANNULI, NROT
      REAL*4, INTENT(IN)    :: PMAP(NROT,NANNULI)
      REAL*4, INTENT(OUT)   :: PFFT((NROT*2),NANNULI)

      INTEGER*4 I, J
      REAL*4 A(NROT*2), WORK, DIV, RADIUS

      DIV   = FLOAT(NROT)

      DO I = 1,NANNULI
         RADIUS = FLOAT(I)
         DO J = 1,NROT
            A(2*J-1) = PMAP(J,I)
            A(2*J) = 0.0
         ENDDO
         CALL FOURT (A, NROT, 1, 1, 0, WORK)
         DO J = 1,NROT*2
            PFFT(J,I) = RADIUS*A(J)/DIV
         ENDDO
      ENDDO
      
      RETURN
      END SUBROUTINE PMAP_FFT
