C  ****************************************************************************
C  *                                                                          *
C  *                    *****     FUNCTION WAVEL     *****                    *
C  *                                                                          *
C  *    COMPUTE ELECTRON WAVELENGTH IN NANOMETERS GIVEN THE VOLTAGE.          *
C  *                                                                          *
C  *    AUGUST 1999 PURDUE UNIVERSITY AlphaStation 500/400, T. BAKER.         *
C  *    LAST MODIFIED 13-AUG-1999 BY T. BAKER                                 *
C  ****************************************************************************
C
      FUNCTION WAVEL (VOLTS)
C
      IMPLICIT NONE
C
      REAL*4 WAVEL, VOLTS
C  ----------------------------------------------------------------------------
C
      WAVEL = 1.23 / SQRT (VOLTS + (1.0E-6 * VOLTS**2))             ! IN NM
C
      RETURN
      END
