      Subroutine cmpt_ctf(fft_klh, hkl_min, hkl_max, fft_ann,
     +     t_analy, mem_cmpt, ctf_val, abs_ctf, disef,
     +     fno, weight)

      implicit none

      include 'mpif.h'
      include '../include/allprogs.inc'
      include '../include/info.inc'
      include '../include/com_01.inc'
      include '../include/vax_minmax.inc'

C     Subroutine arguments

      integer hkl_min, hkl_max, fft_ann, fno
      real    weight
      complex fft_klh(-fft_ann:fft_ann, -fft_ann:fft_ann, 0:fft_ann)
      real    ctf_val( (nfc_2d_row+1)* (2*nfc_2d_col+1) )
      real    abs_ctf( 0:nfc_2d_row, -nfc_2d_col:nfc_2d_col )
      real    disef( 0:nfc_2d_row, -nfc_2d_col:nfc_2d_col )
      double precision mem_cmpt, t_analy

C     Local variables
      integer view, symm, i, j, k, cc, max_node_eq, num_hkl
      integer mem_size, start_view, end_view, last_node,
     +     num_views, tmp_row, tmp_col, radius, nsize
      integer defmaj, defmin, angle, angletmp, ort_out
      integer min_ctfs(1:3), sendcount(0:num_nodes),
     +     disp(0:num_nodes)
      integer alloc_stat, tmp_nangle

      real du, dv
      real    angles_rad(1:3),angles_deg(1:3),center(1:2),imgmagfactor,
     +     num_annul,value,min_value, min_annul, ctfs(1:3)
      double precision part_dist
      real    wavelength, tmaj, fw2
      real    rot_mat(1:3,1:3), 
     +     dist(-Nangle:Nangle,-Nangle:Nangle,-Nangle:Nangle),
     +     sum_dist(-Nangle:Nangle,-Nangle:Nangle,-Nangle:Nangle)
      real    orient(0:6, max_views)
      real    pixels_array(npix_row, npix_col)
      
      real, allocatable :: rffta_omega(:), rffta(:), rffta_trns(:)
      complex, allocatable :: fc_2d(:), fc_2d_intp(:), fc_2d_bak(:)
      
      double precision wtime, t1, t2, time
      
      double precision :: mem_orient = 0.0D0 , mem_pixels = 0.0D0 , 
     +     mem_rffta_omega = 0.0D0 , mem_rffta = 0.0D0 ,
     +     mem_rffta_trns = 0.0D0 , mem_ico_x = 0.0D0 ,
     +     mem_ico_y = 0.0D0 , mem_ico_z = 0.0D0 ,
     +     mem_ico_x_ref = 0.0D0 , mem_ico_y_ref = 0.0D0 ,
     +     mem_ico_z_ref = 0.0D0 , mem_ico_x_original = 0.0D0 ,
     +     mem_ico_y_original = 0.0D0 , mem_ico_z_original = 0.0D0 ,
     +     mem_fc_2d = 0.0D0 

      character(len=12) :: subname = 'cmpt_ctfr'
      character(len=64) fname

C     Allocate storage for subroutine FFTANALY
      mem_size        = nrffta_row * nrffta_col
      allocate(rffta_omega(nrffta_omega), rffta(mem_size),
     +     rffta_trns(mem_size), stat = alloc_stat)
      
      mem_rffta_omega = dble(4 * nrffta_omega)
      mem_rffta       = dble( 4 * mem_size )
      mem_rffta_trns  = dble( 4 * mem_size )
      mem_orient      = dble(4*7*max_views)
      
      nsize    = (2*Nangle+1)*(2*Nangle+1)*(2*Nangle+1)
      mem_cmpt = mem_orient + mem_rffta_omega 
     +     + mem_rffta + mem_rffta_trns + nsize

      if(alloc_stat .gt. 0) then
         call error_stop (progname, subname, 
     +        ' Memory allocation failed for FFT arrays')
      endif

C     to initialize the value of rffta_omega(nrfft_col+15) that is
C     rffta_omega(nrffta_omega) Initialize the FFT parameters used to
C     transform rows of RFFTA each row has length NRFFTA_COL

      call vrffti( nrffta_col, rffta_omega )

      num_views = 0 
      t1 = wtime()

      if( iam .eq. 0 ) then
C     CALL READORIENT
C     ***************
         call readorient(orient, max_views, ort_file_name, num_views,
     +        npix_row, npix_col, oddeven)

         write(stdoutput,1001) iam, ort_file_name, num_views, max_views
 1001    format(/' Node = ',i2,':  Read orientation file: ',a/,
     +        12x,' Number of views     = ', i9, i9)

C     write out new ort file head
         call increment_fname(ort_file_name, ort_out_name)
         ort_out = 11
         OPEN (UNIT=ort_out, FILE=ort_out_name)
         WRITE(ort_out,'(A)') pix_file_name
      endif 

      min_value = R4_MAX
      if (Nangle .eq. 0) goto 1111
      
      if( num_nodes .gt. 1 ) then
         call mpi_bcast(num_views, 1, mpi_integer,
     +        0, mpi_comm_world, mpi_err)
         if( mpi_err .ne. 0 ) call error_stop(progname,subname,
     +        'Error in calling MPI_BCAST num_views')
         
         call mpi_bcast(orient, 7*max_views, mpi_real,
     +        0, mpi_comm_world, mpi_err)
         if( mpi_err .ne. 0 ) call error_stop(progname,subname,
     +        'Error in calling MPI_BCAST orient')
      endif

      num_annul = real(nrffta_row)*angstrom_per_pix/res_max 
      min_annul = real(nrffta_row)*angstrom_per_pix/res_min
      if (num_annul .ge. nrffta_row/2.) 
     +     call error_stop(progname,subname, 
     +     'Resolution is too high, smaller than 2*angstrom_per_pix')
      if (iam.eq.0) then
         print *,min_annul,num_annul,Dangle,Nangle
      endif
      radius = int(num_annul)+1

C     change the minimum radius based on the defocus

      wavelength = 1.2264264967
     +     /sqrt(VOLTS(fno)+ 0.9784663543E-6 * VOLTS(fno)**2)
      tmaj = min(DELF_MAJS(fno),DELF_MINS(fno))
      fw2 = (tmaj-sqrt(tmaj*tmaj - AMPFACS(fno)*wavelength*2.0))
     +     /AMPFACS(fno)
      min_annul=sqrt(fw2/1000.)*(PIXSIZS(fno)*2*hkl_max)/wavelength/10.
      if (min_annul.lt.10.) min_annul= 10.
      if (iam.eq.0) then
         print *, 'change the minimum radius to be', min_annul
      endif

      if( iam .eq. 0 ) then
         WRITE(*,1010) PIXSIZS(fno), units, VOLTS(fno), 
     +        AMPFACS(fno), DELF_MAJS(fno), DELF_MINS(fno), 
     +        ANG_MAJS(fno), CS_COEFFS(fno)
      endif

C     read each views and generate 2DDFT for these views
      call set_indices(num_nodes, 1, num_views,
     +         frst_lst_view, max_node_eq )

C     allocate memory to store cuts,  DFT bakup,
      mem_size        = ( 1 + nfc_2d_row ) * ( 1 + 2 * nfc_2d_col )
      allocate(fc_2d(mem_size), fc_2d_intp(mem_size * max_node_eq),
     +     fc_2d_bak(mem_size * max_node_eq), stat = alloc_stat)
      
      if(alloc_stat .gt. 0) then
         call error_stop (progname, subname, 
     +        ' Memory allocation failed for fc_2d arrays')
      endif

      mem_fc_2d       = dble( (16 * max_node_eq + 8) * mem_size)
      mem_cmpt        = mem_cmpt + mem_fc_2d


      do j = 0, max_node_eq - 1
C     read current one view for all processors
         do i = num_nodes - 1 , 0 , -1
            start_view = frst_lst_view(1,i) + j
            end_view   = frst_lst_view(2,i)
            if (start_view .LE. end_view ) then
C     read one image to each processor one time
               call read_files(pixels_array, start_view,
     +              start_view, i, orient)
            endif
         enddo

         start_view = frst_lst_view(1,iam) + j
         end_view   = frst_lst_view(2,iam)
         if (start_view .GT. end_view) exit !Break out of loop
         call getorient( orient, max_views, start_view,
     +        angles_rad, angles_deg, center, imgmagfactor)
C     adjust the imgmagfactor according to its own pixel_size
         imgmagfactor = imgmagfactor * PIXSIZ_OUT / angstrom_per_pix

C     Compute Discrete Fourier Transform of pixel values:
         call fft_2dfft( pixels_array,
     +        npix_row, npix_col, pixels_array, center,
     +        nrffta_omega, rffta_omega, nrffta_row, 
     +        nrffta_col, nfc_2d_row, 
     +        nfc_2d_col, fc_2d_bak(j*mem_size + 1) )
         du = center(1) - real(int(center(1)))
         dv = center(2) - real(int(center(2)))
         call shift_fft(fc_2d_bak(j*mem_size + 1), 
     +        nfc_2d_row, nfc_2d_col, du, dv)

C     Compute cut for this view:
         angles_rad(3) = -(angles_deg(3)+90.)*deg_to_rad
         call setrotmat( angles_rad, rot_mat)
         call interpl_3d(fft_klh, hkl_min, hkl_max,
     +        min_annul, num_annul,
     +        rot_mat, fc_2d_intp(j*mem_size+1), imgmagfactor, fft_ann)
      enddo 


      t2 = wtime()
      time = t2 - t1
      t_analy = t_analy + time

      do defmaj = -Nangle, Nangle
         do defmin= -Nangle, Nangle
            do angle = -Nangle, Nangle
               dist(defmaj, defmin, angle) = R4_MAX
            enddo
         enddo
      enddo

C     loop to refine CTF, I use min_ctfs and ctfs the temp value of CTF
C     the resolution for defocus is Dangle, and the resolution for angle
C     is Dangle*10

 1110 min_ctfs(1) = 0           ! defocus major
      min_ctfs(2) = 0           ! defocus minor
      min_ctfs(3) = 0           ! the angle
      
C     The logic in the following code has been greatly simplified by
C     using the Fortran 90 do loop features "exit" and "cycle". In
C     addition, a big chunk of redundant code has been eliminated.

      do defmaj = -Nangle, Nangle  
         ctfs(1)= Dangle*defmaj + DELF_MAJS(fno)
         if (ctfs(1).le.0) cycle ! Skip to next iteration
         do defmin = -Nangle, Nangle  
            ctfs(2)= Dangle*defmin + DELF_MINS(fno)
            if (ctfs(2).le.0) cycle ! Skip to next iteration

C     If ctfs(1) equals ctfs(2), then don't need to rotate about
C     angle. To avoid having to reproduce a big chunk of code, set the
C     loop indices based on the result of this test.
            if (ctfs(2) .eq. ctfs(1)) then
               tmp_Nangle = 0
            else
               tmp_Nangle = Nangle
            endif

            do angle = -tmp_Nangle, tmp_Nangle
               ctfs(3) = Dangle*angle*10 + ANG_MAJS(fno)
               if (dist(defmaj,defmin,angle).lt.R4_MAX-1) cycle
               IF (CTFMODE.GT.0 .and. CTFMODE.LE.4)  then
                  call ctf_para(ctf_val, abs_ctf, 
     +                 nfc_2d_row, nfc_2d_col,
     +                 CTFMODE, Filter, -TEMPFAC, CTF_FF1, CTF_FF2,
     +                 PIXSIZS(fno), units, VOLTS(fno),ctfs(1), 
     +                 ctfs(2), ctfs(3), AMPFACS(fno),
     +                 CS_COEFFS(fno), Weight, res_max,res_max)
               endif
               part_dist = 0.0
               start_view = frst_lst_view(1,iam)
               end_view   = frst_lst_view(2,iam)
               do j = 0, max_node_eq - 1
                  start_view = start_view + j
                  if (start_view .GT. end_view) exit !Break out of loop
                  do tmp_row =1,(1+nfc_2d_row)*(1+2*nfc_2d_col) 
                     fc_2d(tmp_row) = 
     +                    fc_2d_bak(j*mem_size + tmp_row)
     +                    * ctf_val(tmp_row)
                  enddo
                  call imgcomport(fc_2d_intp(j*mem_size+1), 
     +                 hkl_min, hkl_max, fc_2d, disef, abs_ctf, 
     +                 min_annul, num_annul, value, funcmode)
                  part_dist = part_dist + value
               enddo
               dist(defmaj, defmin, angle) = part_dist
            enddo

C     Setting rest of dist array elements for ctfs(1) == ctfs(2)
            if (ctfs(2) .eq. ctfs(1)) then
               do angletmp = -Nangle, -1
                  dist(defmaj,defmin,angletmp) = dist(defmaj,defmin,0)+1
               enddo
               do angletmp = 1,Nangle
                  dist(defmaj,defmin,angletmp) = dist(defmaj,defmin,0)+1
               enddo
            endif
               
         enddo
      enddo
      
      call MPI_Allreduce(dist, sum_dist, nsize,
     +     MPI_REAL, MPI_SUM, MPI_COMM_WORLD, mpi_err)

      do defmaj = -Nangle, Nangle
         do defmin= -Nangle, Nangle
            do angle = -Nangle, Nangle
               if ( sum_dist(defmaj, defmin, angle) .lt. min_value) then
                  min_value   = sum_dist(defmaj, defmin, angle)
                  min_ctfs(1) = defmaj
                  min_ctfs(2) = defmin
                  min_ctfs(3) = angle
               endif
            enddo
         enddo
      enddo
      
      if (iam .eq. 0) then
         print *, 'min_value=', min_value,'<=',
     +        min_ctfs(1), min_ctfs(2), min_ctfs(3)
      endif
      
      if ( abs(real(min_ctfs(1))) .gt. Nangle*0.5 .or. 
     +     abs(real(min_ctfs(2))) .gt. Nangle*0.5 .or.
     +     abs(real(min_ctfs(3))) .gt. Nangle*0.5 ) then
         DELF_MAJS(fno) = DELF_MAJS(fno) + min_ctfs(1) * Dangle
         DELF_MINS(fno) = DELF_MINS(fno) + min_ctfs(2) * Dangle
         ANG_MAJS(fno)  = ANG_MAJS(fno)  + min_ctfs(3) * Dangle * 10
         
C     slide dist windows to make min dist value is in center
         call recenter_array_3d(dist, Nangle, min_ctfs, R4_MAX)
         
         goto  1110
      endif

      DELF_MAJS(fno) = DELF_MAJS(fno) + min_ctfs(1) * Dangle
      DELF_MINS(fno) = DELF_MINS(fno) + min_ctfs(2) * Dangle
      ANG_MAJS(fno)  = ANG_MAJS(fno)  + min_ctfs(3) * Dangle * 10
      
C     write out new CTF and orient data
 1111 if( iam .eq. 0 ) then
         WRITE(ort_out,1010) PIXSIZS(fno), units, VOLTS(fno), 
     +        AMPFACS(fno), DELF_MAJS(fno), DELF_MINS(fno), 
     +        ANG_MAJS(fno), CS_COEFFS(fno)
 1010    FORMAT (1X,F8.4,',',I2,',',F10.1,',',4(F10.4,','),F8.2) 
         do view = 1, num_views
            WRITE(ort_out,1020) nint(orient(0, view)) ,
     +           (orient(cc, view),cc=1,6), min_value
         enddo
         CLOSE (UNIT=ort_out)
 1020    FORMAT(I7,',',4(F8.3,','),F7.3,',',F6.3,',',F10.3,',',
     +        ' ,',' ,')
      endif
      if( iam .eq. 0 ) then
         WRITE(*,1010) PIXSIZS(fno), units, VOLTS(fno), 
     +        AMPFACS(fno), DELF_MAJS(fno), DELF_MINS(fno), 
     +        ANG_MAJS(fno), CS_COEFFS(fno)
      endif
      
C     Free memory allocated in this subroutine.
      deallocate(rffta_omega, rffta, rffta_trns,
     +     fc_2d, fc_2d_intp, fc_2d_bak)
      
      return
      end subroutine cmpt_ctf
